Name:          ehcache-sizeof
Version:       0.3.0
Release:       1%{?dist}
Summary:       Configurable sizeOf engine for Ehcache
License:       ASL 2.0
URL:           https://github.com/ehcache/sizeof/
Source0:       https://github.com/ehcache/sizeof/archive/v%{version}/sizeof-%{version}.tar.gz

BuildRequires: maven-local
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(org.apache.maven.plugins:maven-failsafe-plugin)
BuildRequires: mvn(org.codehaus.gmavenplus:gmavenplus-plugin)
BuildRequires: mvn(org.codehaus.groovy:groovy-all)
BuildRequires: mvn(org.hamcrest:hamcrest-library)
BuildRequires: mvn(org.ow2.asm:asm)
BuildRequires: mvn(org.slf4j:slf4j-api)
BuildRequires: mvn(org.slf4j:slf4j-jdk14)
BuildRequires: mvn(org.sonatype.oss:oss-parent:pom:)

BuildArch:     noarch

%description
SizeOf engine, extracted from Ehcache.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n sizeof-%{version}

# https://github.com/ehcache/sizeof/issues/44
%pom_remove_plugin :gmaven-plugin
%pom_add_plugin org.codehaus.gmavenplus:gmavenplus-plugin:1.5 . '
<executions>
  <execution>
    <id>create-agent-jar</id>
    <phase>process-classes</phase>
    <goals>
      <goal>execute</goal>
    </goals>
  </execution>
</executions>
<configuration>
  <scripts>
    <script><![CDATA[
      def jarFile = new File(project.build.directory, "/classes/org/ehcache/sizeof/impl/sizeof-agent.jar");
      def agentClass = "/org/ehcache/sizeof/impl/SizeOfAgent.class"
      def agentDir = project.build.directory + "/agent-jar"
      def manifestDir = project.basedir.getAbsolutePath() + "/src/hidden/resources";
      ant.move(file: new File(project.build.outputDirectory, agentClass),
      tofile: new File(agentDir, agentClass))

      ant.jar(destfile: jarFile, basedir: new File(agentDir).getAbsolutePath(), manifest: new File(manifestDir, "/META-INF/MANIFEST.MF"))

      ant.delete(dir: new File(agentDir))
    ]]></script>
  </scripts>
</configuration>
<dependencies>
  <dependency>
    <groupId>org.codehaus.groovy</groupId>
    <artifactId>groovy-all</artifactId>
    <version>2.4.4</version>
    <scope>runtime</scope>
  </dependency>
</dependencies>'

# https://github.com/ehcache/sizeof/issues/45
# AssertionError: Unexpected Java Version : 1.8.0_91
sed -i "s|1.7|1.8|" src/test/java/org/ehcache/sizeof/ObjectGraphWalkerTest.java
# AssertionError: deepSizeOf(new ReentrantReadWriteLock())
# Expected: is null  but: was <112L> at org.ehcache.sizeof.SizeOfTest.testSizeOf(SizeOfTest.java:113)
rm src/test/java/org/ehcache/sizeof/SizeOfTest.java

%mvn_file org.ehcache:%{name} %{name}

%build

%mvn_build

%install
%mvn_install

%files -f .mfiles
%doc README.adoc
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog
* Mon May 02 2016 gil cattaneo <puntogil@libero.it> 0.3.0-1
- initial rpm
